module Traverse where

import Control.Monad(filterM, mapM_)
import Control.Exception(try)
import System.Directory
import System.FilePath((</>))
import Data.List((\\))
import System.Environment(getArgs)

travFS :: (FilePath-> IO ())-> FilePath-> IO ()
travFS action p = do
  res <- try (getDirectoryContents p)
  case res of
    Left  e -> putStrLn $ "ERROR: "++ show (e :: IOError)
    Right cs -> do let cp = map (p </>) (cs \\ [".", ".."])
                   dirs  <- filterM doesDirectoryExist cp
                   files <- filterM doesFileExist cp
                   mapM_ action files
                   mapM_ (travFS action) dirs

-- Problem: follows symbolic links blindly. This line would help
--
--                 dirs  <- filterM (\c-> doesDirectoryExist c &&
--                                        not (isSymbolicLink c)) cp
--
-- ... but unfortunately, isSymbolicLink is not provided in System.Directory
-- of ghc 7.10.3.

main :: IO ()
main = do
  args <- getArgs
  mapM_ (travFS putStrLn) args

