module Main where

import System.Environment (getArgs)
import Control.Exception

-- The actual counting function
wc :: String-> IO ()
wc file = 
  do cont <- readFile file
     putStrLn $ file++ ": "++ 
                show (length (lines cont), 
                      length (words cont), 
                      length cont)

-- Wrap up wc in an error handler
wc2 :: String-> IO ()
wc2 file = 
  catch (wc file)
        (\e -> putStrLn $ "Fehler: "++ show (e :: IOError))

-- Main function, reads command line arguments and counts wc2
main :: IO ()
main = do 
  args <- getArgs
  mapM_ wc2 args    

